/* optcc.h
 * Header file for C-style interface to the OPT library
 * generated by apiwrapper
 */

#if ! defined(_OPTCC_H_)
#     define  _OPTCC_H_


enum optDataType {
  optDataNone    = 0,
  optDataInteger = 1,
  optDataDouble  = 2,
  optDataString  = 3,
  optDataStrList = 4  };

enum optOptionType {
  optTypeInteger   = 0,
  optTypeDouble    = 1,
  optTypeString    = 2,
  optTypeBoolean   = 3,
  optTypeEnumStr   = 4,
  optTypeEnumInt   = 5,
  optTypeMultiList = 6,
  optTypeStrList   = 7,
  optTypeMacro     = 8,
  optTypeImmediate = 9  };

enum optOptionSubType {
  optsubRequired = 0,
  optsubNoValue  = 1,
  optsubOptional = 2,
  optsub2Values  = 3  };

enum optMsgType {
  optMsgInputEcho    = 0,
  optMsgHelp         = 1,
  optMsgDefineError  = 2,
  optMsgValueError   = 3,
  optMsgValueWarning = 4,
  optMsgDeprecated   = 5,
  optMsgFileEnter    = 6,
  optMsgFileLeave    = 7,
  optMsgTooManyMsgs  = 8,
  optMsgUserError    = 9  };


#if defined(_WIN32)
# include <windows.h>
# define OPT_CALLCONV __stdcall
#else
# define OPT_CALLCONV
#endif

#if defined(__cplusplus)
extern "C" {
#endif

struct optRec;
typedef struct optRec *optHandle_t;

typedef int (*optErrorCallback_t) (int ErrCount, const char *msg);
extern int optAPIErrorCount;

/* headers for "wrapper" routines implemented in C */
int optGetReady  (char *msgBuf, int msgBufLen);
int optGetReadyD (const char *dirName, char *msgBuf, int msgBufLen);
int optGetReadyL (const char *libName, char *msgBuf, int msgBufLen);
int optCreate    (optHandle_t *popt, char *msgBuf, int msgBufLen);
int optCreateD   (optHandle_t *popt, const char *dirName, char *msgBuf, int msgBufLen);
int optCreateL   (optHandle_t *popt, const char *libName, char *msgBuf, int msgBufLen);
int optFree      (optHandle_t *popt);

int optLibraryLoaded(void);
int optLibraryUnload(void);

int  optGetScreenIndicator   (void);
void optSetScreenIndicator   (int scrind);
int  optGetExceptionIndicator(void);
void optSetExceptionIndicator(int excind);
int  optGetExitIndicator     (void);
void optSetExitIndicator     (int extind);
optErrorCallback_t optGetErrorCallback(void);
void optSetErrorCallback(optErrorCallback_t func);

void optErrorHandling(const char *msg);


#if defined(OPT_MAIN)    /* we must define some things only once */
# define OPT_FUNCPTR(NAME)  NAME##_t NAME = NULL
#else
# define OPT_FUNCPTR(NAME)  extern NAME##_t NAME
#endif

/* function typedefs and pointer definitions */

typedef int  (OPT_CALLCONV *optReadDefinition_t) (optHandle_t popt, const char *fn);
OPT_FUNCPTR(optReadDefinition);
typedef int  (OPT_CALLCONV *optReadParameterFile_t) (optHandle_t popt, const char *fn);
OPT_FUNCPTR(optReadParameterFile);
typedef void  (OPT_CALLCONV *optReadFromStr_t) (optHandle_t popt, const char *s);
OPT_FUNCPTR(optReadFromStr);
typedef int  (OPT_CALLCONV *optWriteParameterFile_t) (optHandle_t popt, const char *fn);
OPT_FUNCPTR(optWriteParameterFile);
typedef void  (OPT_CALLCONV *optClearMessages_t) (optHandle_t popt);
OPT_FUNCPTR(optClearMessages);
typedef void  (OPT_CALLCONV *optAddMessage_t) (optHandle_t popt, const char *info);
OPT_FUNCPTR(optAddMessage);
typedef void  (OPT_CALLCONV *optGetMessage_t) (optHandle_t popt, int N, char *info, int *iType);
OPT_FUNCPTR(optGetMessage);
typedef void  (OPT_CALLCONV *optResetAll_t) (optHandle_t popt);
OPT_FUNCPTR(optResetAll);
typedef void  (OPT_CALLCONV *optResetAllRecent_t) (optHandle_t popt);
OPT_FUNCPTR(optResetAllRecent);
typedef void  (OPT_CALLCONV *optResetRecentChanges_t) (optHandle_t popt);
OPT_FUNCPTR(optResetRecentChanges);
typedef void  (OPT_CALLCONV *optShowHelp_t) (optHandle_t popt, const char *HlpID);
OPT_FUNCPTR(optShowHelp);
typedef int  (OPT_CALLCONV *optResetNr_t) (optHandle_t popt, int ANr);
OPT_FUNCPTR(optResetNr);
typedef int  (OPT_CALLCONV *optFindStr_t) (optHandle_t popt, const char *AName, int *ANr, int *ARefNr);
OPT_FUNCPTR(optFindStr);
typedef int  (OPT_CALLCONV *optGetInfoNr_t) (optHandle_t popt, int ANr, int *ADefined, int *ADefinedR, int *ARefNr, int *ADataType, int *AOptType, int *ASubType);
OPT_FUNCPTR(optGetInfoNr);
typedef int  (OPT_CALLCONV *optGetValuesNr_t) (optHandle_t popt, int ANr, char *ASName, int *AIVal, double *ADVal, char *ASVal);
OPT_FUNCPTR(optGetValuesNr);
typedef int  (OPT_CALLCONV *optSetValuesNr_t) (optHandle_t popt, int ANr, int AIVal, double ADVal, const char *ASVal);
OPT_FUNCPTR(optSetValuesNr);
typedef int  (OPT_CALLCONV *optSetValues2Nr_t) (optHandle_t popt, int ANr, int AIVal, double ADVal, const char *ASVal);
OPT_FUNCPTR(optSetValues2Nr);
typedef void  (OPT_CALLCONV *optVersion_t) (optHandle_t popt, char *sversion);
OPT_FUNCPTR(optVersion);
typedef void  (OPT_CALLCONV *optDefinitionFile_t) (optHandle_t popt, char *sfilename);
OPT_FUNCPTR(optDefinitionFile);
typedef int  (OPT_CALLCONV *optGetFromAnyStrList_t) (optHandle_t popt, int idash, char *skey, char *sval);
OPT_FUNCPTR(optGetFromAnyStrList);
typedef int  (OPT_CALLCONV *optGetFromListStr_t) (optHandle_t popt, const char *skey, char *sval);
OPT_FUNCPTR(optGetFromListStr);
typedef int  (OPT_CALLCONV *optListCountStr_t) (optHandle_t popt, const char *skey);
OPT_FUNCPTR(optListCountStr);
typedef int  (OPT_CALLCONV *optReadFromListStr_t) (optHandle_t popt, const char *skey, int iPos, char *sval);
OPT_FUNCPTR(optReadFromListStr);
typedef int  (OPT_CALLCONV *optSynonymCount_t) (optHandle_t popt);
OPT_FUNCPTR(optSynonymCount);
typedef int  (OPT_CALLCONV *optGetSynonym_t) (optHandle_t popt, int N, char *SSyn, char *SName);
OPT_FUNCPTR(optGetSynonym);
typedef void  (OPT_CALLCONV *optEchoSet_t) (optHandle_t popt, int V);
OPT_FUNCPTR(optEchoSet);
typedef int  (OPT_CALLCONV *optEOLOnlySet_t) (optHandle_t popt, int ival);
OPT_FUNCPTR(optEOLOnlySet);
typedef void  (OPT_CALLCONV *optNoBoundsSet_t) (optHandle_t popt, int ival);
OPT_FUNCPTR(optNoBoundsSet);
typedef void  (OPT_CALLCONV *optErrorCount_t) (optHandle_t popt, int *iErrors, int *iWarnings);
OPT_FUNCPTR(optErrorCount);
typedef int  (OPT_CALLCONV *optGetBoundsInt_t) (optHandle_t popt, int ANr, int *ilval, int *ihval, int *idval);
OPT_FUNCPTR(optGetBoundsInt);
typedef int  (OPT_CALLCONV *optGetBoundsDbl_t) (optHandle_t popt, int ANr, double *dlval, double *dhval, double *ddval);
OPT_FUNCPTR(optGetBoundsDbl);
typedef int  (OPT_CALLCONV *optGetDefaultStr_t) (optHandle_t popt, int ANr, char *sval);
OPT_FUNCPTR(optGetDefaultStr);
typedef int  (OPT_CALLCONV *optGetIntNr_t) (optHandle_t popt, int ANr, int *AIVal);
OPT_FUNCPTR(optGetIntNr);
typedef int  (OPT_CALLCONV *optGetInt2Nr_t) (optHandle_t popt, int ANr, int *AIVal);
OPT_FUNCPTR(optGetInt2Nr);
typedef int  (OPT_CALLCONV *optSetIntNr_t) (optHandle_t popt, int ANr, int AIVal);
OPT_FUNCPTR(optSetIntNr);
typedef int  (OPT_CALLCONV *optSetInt2Nr_t) (optHandle_t popt, int ANr, int AIVal);
OPT_FUNCPTR(optSetInt2Nr);
typedef int  (OPT_CALLCONV *optGetStrNr_t) (optHandle_t popt, int ANr, char *ASVal);
OPT_FUNCPTR(optGetStrNr);
typedef int  (OPT_CALLCONV *optGetOptHelpNr_t) (optHandle_t popt, int ANr, char *AName, int *AHc, int *AGroup);
OPT_FUNCPTR(optGetOptHelpNr);
typedef int  (OPT_CALLCONV *optGetEnumHelp_t) (optHandle_t popt, int ANr, int AOrd, int *AHc, char *AHelpStr);
OPT_FUNCPTR(optGetEnumHelp);
typedef int  (OPT_CALLCONV *optGetEnumStrNr_t) (optHandle_t popt, int ANr, char *ASVal, int *AOrd);
OPT_FUNCPTR(optGetEnumStrNr);
typedef int  (OPT_CALLCONV *optGetEnumCount_t) (optHandle_t popt, int ANr, int *ACount);
OPT_FUNCPTR(optGetEnumCount);
typedef int  (OPT_CALLCONV *optGetEnumValue_t) (optHandle_t popt, int ANr, int AOrd, int *AValInt, char *AValStr);
OPT_FUNCPTR(optGetEnumValue);
typedef int  (OPT_CALLCONV *optGetStr2Nr_t) (optHandle_t popt, int ANr, char *ASVal);
OPT_FUNCPTR(optGetStr2Nr);
typedef int  (OPT_CALLCONV *optSetStrNr_t) (optHandle_t popt, int ANr, const char *ASVal);
OPT_FUNCPTR(optSetStrNr);
typedef int  (OPT_CALLCONV *optSetStr2Nr_t) (optHandle_t popt, int ANr, const char *ASVal);
OPT_FUNCPTR(optSetStr2Nr);
typedef int  (OPT_CALLCONV *optGetDblNr_t) (optHandle_t popt, int ANr, double *ADVal);
OPT_FUNCPTR(optGetDblNr);
typedef int  (OPT_CALLCONV *optGetDbl2Nr_t) (optHandle_t popt, int ANr, double *ADVal);
OPT_FUNCPTR(optGetDbl2Nr);
typedef int  (OPT_CALLCONV *optSetDblNr_t) (optHandle_t popt, int ANr, double ADVal);
OPT_FUNCPTR(optSetDblNr);
typedef int  (OPT_CALLCONV *optSetDbl2Nr_t) (optHandle_t popt, int ANr, double ADVal);
OPT_FUNCPTR(optSetDbl2Nr);
typedef int  (OPT_CALLCONV *optGetValStr_t) (optHandle_t popt, const char *AName, char *ASVal);
OPT_FUNCPTR(optGetValStr);
typedef int  (OPT_CALLCONV *optGetVal2Str_t) (optHandle_t popt, const char *AName, char *ASVal);
OPT_FUNCPTR(optGetVal2Str);
typedef int  (OPT_CALLCONV *optGetNameNr_t) (optHandle_t popt, int ANr, char *ASName);
OPT_FUNCPTR(optGetNameNr);
typedef int  (OPT_CALLCONV *optGetDefinedNr_t) (optHandle_t popt, int ANr, int *AIVal);
OPT_FUNCPTR(optGetDefinedNr);
typedef int  (OPT_CALLCONV *optGetHelpNr_t) (optHandle_t popt, int ANr, char *ASOpt, char *ASHelp);
OPT_FUNCPTR(optGetHelpNr);
typedef int  (OPT_CALLCONV *optGetGroupNr_t) (optHandle_t popt, int ANr, char *AName, int *AGroup, int *AHc, char *AHelp);
OPT_FUNCPTR(optGetGroupNr);
typedef int  (OPT_CALLCONV *optGetGroupGrpNr_t) (optHandle_t popt, int AGroup);
OPT_FUNCPTR(optGetGroupGrpNr);
typedef int  (OPT_CALLCONV *optGetOptGroupNr_t) (optHandle_t popt, int ANr);
OPT_FUNCPTR(optGetOptGroupNr);
typedef int  (OPT_CALLCONV *optGetDotOptNr_t) (optHandle_t popt, int ANr, char *AName, int *AObjNr, int *ADim, double *AValue);
OPT_FUNCPTR(optGetDotOptNr);
typedef int  (OPT_CALLCONV *optGetDotOptUel_t) (optHandle_t popt, int ANr, int ADim, char *AUEL);
OPT_FUNCPTR(optGetDotOptUel);
typedef int  (OPT_CALLCONV *optGetIndicatorNr_t) (optHandle_t popt, int ANr, char *EquName, char *VarName, int *EquDim, int *VarDim, int *AValue);
OPT_FUNCPTR(optGetIndicatorNr);
typedef int  (OPT_CALLCONV *optGetEquIndicatorNr_t) (optHandle_t popt, int ANr, int ADim, char *AIndex);
OPT_FUNCPTR(optGetEquIndicatorNr);
typedef int  (OPT_CALLCONV *optGetVarIndicatorNr_t) (optHandle_t popt, int ANr, int ADim, char *AIndex);
OPT_FUNCPTR(optGetVarIndicatorNr);
typedef int  (OPT_CALLCONV *optIndicatorCount_t) (optHandle_t popt, int *ANrErrors);
OPT_FUNCPTR(optIndicatorCount);
typedef int  (OPT_CALLCONV *optDotOptCount_t) (optHandle_t popt, int *ANrErrors);
OPT_FUNCPTR(optDotOptCount);
typedef int  (OPT_CALLCONV *optSetRefNr_t) (optHandle_t popt, int ANr, int AValue);
OPT_FUNCPTR(optSetRefNr);
typedef int  (OPT_CALLCONV *optSetRefNrStr_t) (optHandle_t popt, const char *AOpt, int AValue);
OPT_FUNCPTR(optSetRefNrStr);
typedef int  (OPT_CALLCONV *optGetConstName_t) (optHandle_t popt, int cgroup, int cindex, char *cname);
OPT_FUNCPTR(optGetConstName);
typedef int  (OPT_CALLCONV *optGetTypeName_t) (optHandle_t popt, int TNr, char *sTName);
OPT_FUNCPTR(optGetTypeName);
typedef int  (OPT_CALLCONV *optLookUp_t) (optHandle_t popt, const char *AOpt);
OPT_FUNCPTR(optLookUp);
typedef void  (OPT_CALLCONV *optReadFromPChar_t) (optHandle_t popt, char *p);
OPT_FUNCPTR(optReadFromPChar);
typedef int  (OPT_CALLCONV *optCount_t) (optHandle_t popt);
OPT_FUNCPTR(optCount);
typedef int  (OPT_CALLCONV *optMessageCount_t) (optHandle_t popt);
OPT_FUNCPTR(optMessageCount);
typedef int  (OPT_CALLCONV *optGroupCount_t) (optHandle_t popt);
OPT_FUNCPTR(optGroupCount);
typedef int  (OPT_CALLCONV *optRecentEnabled_t) (optHandle_t popt);
OPT_FUNCPTR(optRecentEnabled);
typedef void (OPT_CALLCONV *optRecentEnabledSet_t) (optHandle_t popt, int x);
OPT_FUNCPTR(optRecentEnabledSet);
#if defined(__cplusplus)
}
#endif
#endif /* #if ! defined(_OPTCC_H_) */
